Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs	(revision 2796)
@@ -112,7 +112,7 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.valuePanel.Controls.Add(this.viewHost);
-      this.valuePanel.Location = new System.Drawing.Point(6, 48);
+      this.valuePanel.Location = new System.Drawing.Point(6, 49);
       this.valuePanel.Name = "valuePanel";
-      this.valuePanel.Size = new System.Drawing.Size(347, 100);
+      this.valuePanel.Size = new System.Drawing.Size(347, 99);
       this.valuePanel.TabIndex = 2;
       this.valuePanel.DragOver += new System.Windows.Forms.DragEventHandler(this.valuePanel_DragEnterOver);
@@ -122,9 +122,9 @@
       // viewHost
       // 
+      this.viewHost.Content = null;
       this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
       this.viewHost.Location = new System.Drawing.Point(0, 0);
       this.viewHost.Name = "viewHost";
-      this.viewHost.Content = null;
-      this.viewHost.Size = new System.Drawing.Size(347, 100);
+      this.viewHost.Size = new System.Drawing.Size(347, 99);
       this.viewHost.TabIndex = 0;
       // 
@@ -132,7 +132,7 @@
       // 
       this.clearValueButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Remove;
-      this.clearValueButton.Location = new System.Drawing.Point(35, 19);
+      this.clearValueButton.Location = new System.Drawing.Point(36, 19);
       this.clearValueButton.Name = "clearValueButton";
-      this.clearValueButton.Size = new System.Drawing.Size(23, 23);
+      this.clearValueButton.Size = new System.Drawing.Size(24, 24);
       this.clearValueButton.TabIndex = 1;
       this.toolTip.SetToolTip(this.clearValueButton, "Clear Value");
@@ -145,5 +145,5 @@
       this.setValueButton.Location = new System.Drawing.Point(6, 19);
       this.setValueButton.Name = "setValueButton";
-      this.setValueButton.Size = new System.Drawing.Size(23, 23);
+      this.setValueButton.Size = new System.Drawing.Size(24, 24);
       this.setValueButton.TabIndex = 1;
       this.toolTip.SetToolTip(this.setValueButton, "Set Value");
Index: /trunk/sources/HeuristicLab.Core/3.3/Engine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2796)
@@ -22,10 +22,8 @@
 using System;
 using System.Collections.Generic;
-using System.Text;
-using System.Xml;
+using System.Drawing;
 using System.Threading;
-using System.Drawing;
+using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Core {
@@ -41,10 +39,7 @@
     }
 
-    /// <summary>
-    /// Field of the current instance that represent the operator graph.
-    /// </summary>
     private OperatorGraph operatorGraph;
     /// <summary>
-    /// Gets the current operator graph.
+    /// Gets or sets the current operator graph.
     /// </summary>
     [Storable]
@@ -76,4 +71,21 @@
 
     [Storable]
+    private IProblem problem;
+    /// <summary>
+    /// Gets or sets the current problem.
+    /// </summary>
+    public IProblem Problem {
+      get { return problem; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if (value != problem) {
+          problem = value;
+          OnProblemChanged();
+          Prepare();
+        }
+      }
+    }
+
+    [Storable]
     private TimeSpan executionTime;
     /// <summary>
@@ -134,4 +146,5 @@
     protected Engine() {
       globalScope = new Scope("Global");
+      problem = null;
       executionStack = new Stack<IExecutionSequence>();
       OperatorGraph = new OperatorGraph();
@@ -149,4 +162,5 @@
       clone.OperatorGraph = (OperatorGraph)cloner.Clone(operatorGraph);
       clone.globalScope = (Scope)cloner.Clone(globalScope);
+      clone.problem = (IProblem)cloner.Clone(problem);
       clone.executionTime = executionTime;
       IExecutionSequence[] contexts = executionStack.ToArray();
@@ -169,6 +183,6 @@
       ExecutionTime = new TimeSpan();
       executionStack.Clear();
-      if (OperatorGraph.InitialOperator != null)
-        executionStack.Push(new ExecutionContext(null, OperatorGraph.InitialOperator, GlobalScope));
+      if ((OperatorGraph.InitialOperator != null) && (Problem != null))
+        executionStack.Push(new ExecutionContext(null, OperatorGraph.InitialOperator, GlobalScope, Problem));
       OnPrepared();
     }
@@ -228,8 +242,25 @@
     }
 
+    /// <summary>
+    /// Occurs when the operator graph was changed.
+    /// </summary>
     public event EventHandler OperatorGraphChanged;
+    /// <summary>
+    /// Fires a new <c>OperatorGraphChanged</c> event.
+    /// </summary>
     protected virtual void OnOperatorGraphChanged() {
       if (OperatorGraphChanged != null)
         OperatorGraphChanged(this, EventArgs.Empty);
+    }
+    /// <summary>
+    /// Occurs when the problem was changed.
+    /// </summary>
+    public event EventHandler ProblemChanged;
+    /// <summary>
+    /// Fires a new <c>ProblemChanged</c> event.
+    /// </summary>
+    protected virtual void OnProblemChanged() {
+      if (ProblemChanged != null)
+        ProblemChanged(this, EventArgs.Empty);
     }
     /// <summary>
Index: /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2796)
@@ -45,14 +45,22 @@
     }
 
+    [Storable]
+    private IProblem problem;
+    public IProblem Problem {
+      get { return problem; }
+    }
+
     private ExecutionContext() {
       parent = null;
       op = null;
       scope = null;
+      problem = null;
     }
-    public ExecutionContext(ExecutionContext parent, IOperator op, IScope scope) {
-      if ((op == null) || (scope == null)) throw new ArgumentNullException();
+    public ExecutionContext(ExecutionContext parent, IOperator op, IScope scope, IProblem problem) {
+      if ((op == null) || (scope == null) || (problem == null)) throw new ArgumentNullException();
       this.parent = parent;
       this.op = op;
       this.scope = scope;
+      this.problem = problem;
     }
 
@@ -63,5 +71,19 @@
       clone.op = (IOperator)cloner.Clone(op);
       clone.scope = (IScope)cloner.Clone(scope);
+      clone.problem = (IProblem)cloner.Clone(problem);
       return clone;
+    }
+
+    public ExecutionContext CreateContext(IOperator op) {
+      return new ExecutionContext(parent, op, scope, problem);
+    }
+    public ExecutionContext CreateContext(IOperator op, IScope scope) {
+      return new ExecutionContext(parent, op, scope, problem);
+    }
+    public ExecutionContext CreateChildContext(IOperator op) {
+      return new ExecutionContext(this, op, scope, problem);
+    }
+    public ExecutionContext CreateChildContext(IOperator op, IScope scope) {
+      return new ExecutionContext(this, op, scope, problem);
     }
   }
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2796)
@@ -104,4 +104,6 @@
     <Compile Include="ChangedEventArgs.cs" />
     <None Include="HeuristicLabCorePlugin.cs.frame" />
+    <Compile Include="ValueParameterCollection.cs" />
+    <Compile Include="Interfaces\IProblem.cs" />
     <Compile Include="Interfaces\IExecutionSequence.cs" />
     <Compile Include="Interfaces\IValueLookupParameter.cs" />
@@ -115,4 +117,6 @@
     <Compile Include="Item.cs" />
     <Compile Include="NamedItem.cs" />
+    <Compile Include="Operator.cs" />
+    <Compile Include="Problem.cs" />
     <Compile Include="OperatorGraph.cs" />
     <Compile Include="Interfaces\IParameter.cs" />
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 2796)
@@ -21,6 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Common;
 
@@ -40,4 +38,8 @@
     /// </summary>
     IScope GlobalScope { get; }
+    /// <summary>
+    /// Gets the problem of the current instance.
+    /// </summary>
+    IProblem Problem { get; set; }
 
     /// <summary>
@@ -72,5 +74,12 @@
     void Stop();
 
+    /// <summary>
+    /// Occurs when the operator graph was changed.
+    /// </summary>
     event EventHandler OperatorGraphChanged;
+    /// <summary>
+    /// Occurs when the problem was changed.
+    /// </summary>
+    event EventHandler ProblemChanged;
     /// <summary>
     /// Occurs when the execution time was changed.
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs	(revision 2796)
@@ -26,8 +26,11 @@
 
 namespace HeuristicLab.Core {
-  public interface ILookupParameter<T> : IParameter where T : class, IItem {
+  public interface ILookupParameter : IParameter {
     string ActualName { get; set; }
-
     event EventHandler ActualNameChanged;
   }
+
+  public interface ILookupParameter<T> : ILookupParameter where T : class, IItem {
+    new T ActualValue { get; set; }
+  }
 }
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProblem.cs	(revision 2796)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IProblem.cs	(revision 2796)
@@ -0,0 +1,31 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent a problem.
+  /// </summary>
+  public interface IProblem : INamedItem {
+    IObservableKeyedCollection<string, IValueParameter> Parameters { get; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs	(revision 2796)
@@ -26,4 +26,6 @@
 
 namespace HeuristicLab.Core {
-  public interface IValueLookupParameter<T> : IValueParameter<T>, ILookupParameter<T> where T : class, IItem { }
+  public interface IValueLookupParameter : IValueParameter, ILookupParameter { }
+
+  public interface IValueLookupParameter<T> : IValueLookupParameter, IValueParameter<T>, ILookupParameter<T> where T : class, IItem { }
 }
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs	(revision 2796)
@@ -26,8 +26,11 @@
 
 namespace HeuristicLab.Core {
-  public interface IValueParameter<T> : IParameter where T : class, IItem {
-    T Value { get; set; }
-
+  public interface IValueParameter : IParameter {
+    IItem Value { get; set; }
     event EventHandler ValueChanged;
   }
+
+  public interface IValueParameter<T> : IValueParameter where T : class, IItem {
+    new T Value { get; set; }
+  }
 }
Index: /trunk/sources/HeuristicLab.Core/3.3/Operator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Operator.cs	(revision 2796)
+++ /trunk/sources/HeuristicLab.Core/3.3/Operator.cs	(revision 2796)
@@ -0,0 +1,184 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Collections;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// The base class for all operators.
+  /// </summary>
+  [Item("Operator", "Base class for operators.")]
+  public abstract class Operator : NamedItem, IOperator {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Method; }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
+    }
+
+    private ParameterCollection parameters;
+    [Storable]
+    protected ParameterCollection Parameters {
+      get { return parameters;}
+      private set {
+        if (parameters != null) parameters.Changed -= new ChangedEventHandler(Parameters_Changed);
+        parameters = value;
+        readOnlyParameters = null;
+        if (parameters != null) parameters.Changed += new ChangedEventHandler(Parameters_Changed);
+      }
+    }
+    private ReadOnlyObservableKeyedCollection<string, IParameter> readOnlyParameters;
+    IObservableKeyedCollection<string, IParameter> IOperator.Parameters {
+      get {
+        if (readOnlyParameters == null) readOnlyParameters = parameters.AsReadOnly();
+        return readOnlyParameters;
+      }
+    }
+
+    [Storable]
+    private ExecutionContext executionContext;
+    protected ExecutionContext ExecutionContext {
+      get { return executionContext; }
+      private set {
+        if (value != executionContext) {
+          executionContext = value;
+          OnExecutionContextChanged();
+        }
+      }
+    }
+
+    /// <summary>
+    /// Flag whether the current instance has been canceled.
+    /// </summary>
+    private bool canceled;
+    /// <inheritdoc/>
+    protected bool Canceled {
+      get { return canceled; }
+      private set {
+        if (value != canceled) {
+          canceled = value;
+          OnCanceledChanged();
+        }
+      }
+    }
+
+    [Storable]
+    private bool breakpoint;
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="OnBreakpointChanged"/> in the setter.</remarks>
+    public bool Breakpoint {
+      get { return breakpoint; }
+      set {
+        if (value != breakpoint) {
+          breakpoint = value;
+          OnBreakpointChanged();
+        }
+      }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorBase"/> setting the breakpoint flag and 
+    /// the canceled flag to <c>false</c> and the name of the operator to the type name. 
+    /// </summary>
+    protected Operator() {
+      Name = ItemName;
+      Parameters = new ParameterCollection();
+      readOnlyParameters = null;
+      canceled = false;
+      breakpoint = false;
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Clones also sub operators, variables and variable infos.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="OperatorBase"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Operator clone = (Operator)base.Clone(cloner);
+      clone.Parameters = (ParameterCollection)cloner.Clone(parameters);
+      clone.canceled = canceled;
+      clone.breakpoint = breakpoint;
+      clone.executionContext = (ExecutionContext)cloner.Clone(executionContext);
+      return clone;
+    }
+
+    /// <inheritdoc/>
+    public virtual IExecutionSequence Execute(ExecutionContext context) {
+      try {
+        Canceled = false;
+        ExecutionContext = context;
+        foreach (IParameter param in Parameters)
+          param.ExecutionContext = context;
+        IExecutionSequence next = Apply();
+        OnExecuted();
+        return next;
+      }
+      finally {
+        foreach (IParameter param in Parameters)
+          param.ExecutionContext = null;
+        ExecutionContext = null;
+      }
+    }
+    /// <inheritdoc/>
+    /// <remarks>Sets property <see cref="Canceled"/> to <c>true</c>.</remarks>
+    public void Abort() {
+      Canceled = true;
+    }
+    /// <summary>
+    /// Performs the current operator on the specified <paramref name="scope"/>.
+    /// </summary>
+    /// <param name="scope">The scope where to execute the operator</param>
+    /// <returns><c>null</c>.</returns>
+    public abstract IExecutionSequence Apply();
+
+    protected virtual void OnExecutionContextChanged() { }
+    protected virtual void OnCanceledChanged() { }
+    /// <inheritdoc/>
+    public event EventHandler BreakpointChanged;
+    /// <summary>
+    /// Fires a new <c>BreakpointChanged</c> event.
+    /// </summary>
+    protected virtual void OnBreakpointChanged() {
+      if (BreakpointChanged != null) {
+        BreakpointChanged(this, EventArgs.Empty);
+      }
+      OnChanged();
+    }
+    /// <inheritdoc/>
+    public event EventHandler Executed;
+    /// <summary>
+    /// Fires a new <c>Executed</c> event.
+    /// </summary>
+    protected virtual void OnExecuted() {
+      if (Executed != null) {
+        Executed(this, EventArgs.Empty);
+      }
+    }
+
+    private void Parameters_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2796)
@@ -34,5 +34,5 @@
   /// </summary>
   [Item("OperatorGraph", "Represents a graph of operators.")]
-  [Creatable("Test")]
+  [Creatable("Algorithms")]
   public class OperatorGraph : Item {
     private OperatorSet operators;
Index: /trunk/sources/HeuristicLab.Core/3.3/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Problem.cs	(revision 2796)
+++ /trunk/sources/HeuristicLab.Core/3.3/Problem.cs	(revision 2796)
@@ -0,0 +1,72 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// The base class for all problems.
+  /// </summary>
+  [Item("Problem", "Base class for problems.")]
+  public abstract class Problem : NamedItem, IProblem {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Type; }
+    }
+
+    private ValueParameterCollection parameters;
+    [Storable]
+    protected ValueParameterCollection Parameters {
+      get { return parameters;}
+      private set {
+        if (parameters != null) parameters.Changed -= new ChangedEventHandler(Parameters_Changed);
+        parameters = value;
+        readOnlyParameters = null;
+        if (parameters != null) parameters.Changed += new ChangedEventHandler(Parameters_Changed);
+      }
+    }
+    private ReadOnlyObservableKeyedCollection<string, IValueParameter> readOnlyParameters;
+    IObservableKeyedCollection<string, IValueParameter> IProblem.Parameters {
+      get {
+        if (readOnlyParameters == null) readOnlyParameters = parameters.AsReadOnly();
+        return readOnlyParameters;
+      }
+    }
+
+    protected Problem() {
+      Name = ItemName;
+      Parameters = new ValueParameterCollection();
+      readOnlyParameters = null;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Problem clone = (Problem)base.Clone(cloner);
+      clone.Parameters = (ValueParameterCollection)cloner.Clone(parameters);
+      return clone;
+    }
+
+    private void Parameters_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/ValueParameterCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ValueParameterCollection.cs	(revision 2796)
+++ /trunk/sources/HeuristicLab.Core/3.3/ValueParameterCollection.cs	(revision 2796)
@@ -0,0 +1,34 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  [EmptyStorableClass]
+  [Item("ValueParameterCollection", "Represents a collection of value parameters.")]
+  [Creatable("Test")]
+  public class ValueParameterCollection : NamedItemCollection<IValueParameter> {
+    public ValueParameterCollection() : base() { }
+    public ValueParameterCollection(int capacity) : base(capacity) { }
+    public ValueParameterCollection(IEnumerable<IValueParameter> collection) : base(collection) { }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs	(revision 2796)
@@ -20,11 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
 using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 2796)
@@ -71,10 +71,4 @@
     </Compile>
     <Compile Include="HeuristicLabOperatorsViewsPlugin.cs" />
-    <Compile Include="OperatorView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="OperatorView.Designer.cs">
-      <DependentUpon>OperatorView.cs</DependentUpon>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame	(revision 2796)
@@ -20,7 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.PluginInfrastructure;
 
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/MultipleCallsOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/MultipleCallsOperatorView.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/MultipleCallsOperatorView.cs	(revision 2796)
@@ -20,11 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
 using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs	(revision 2796)
@@ -20,11 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
 using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
Index: /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2796)
@@ -66,5 +66,5 @@
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (operatorGraph.InitialOperator != null)
-        next.Insert(0, new ExecutionContext(ExecutionContext, operatorGraph.InitialOperator, ExecutionContext.Scope));
+        next.Insert(0, ExecutionContext.CreateChildContext(operatorGraph.InitialOperator));
       return next;
     }
Index: /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 2796)
@@ -61,7 +61,7 @@
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (ConditionParameter.ActualValue.Value) {
-        if (TrueBranch != null) next.Insert(0, new ExecutionContext(ExecutionContext.Parent, TrueBranch, ExecutionContext.Scope));
+        if (TrueBranch != null) next.Insert(0, ExecutionContext.CreateContext(TrueBranch));
       } else {
-        if (FalseBranch != null) next.Insert(0, new ExecutionContext(ExecutionContext.Parent, FalseBranch, ExecutionContext.Scope));
+        if (FalseBranch != null) next.Insert(0, ExecutionContext.CreateContext(FalseBranch));
       }
       return next;
Index: /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2796)
@@ -108,5 +108,4 @@
     </Compile>
     <Compile Include="HeuristicLabOperatorsPlugin.cs" />
-    <Compile Include="Operator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="SingleSuccessorOperator.cs" />
Index: /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2796)
@@ -110,5 +110,5 @@
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       for (int i = Operators.Count - 1; i >= 0; i--)
-        next.Insert(0, new ExecutionContext(ExecutionContext.Parent, Operators[i], ExecutionContext.Scope));
+        next.Insert(0, ExecutionContext.CreateContext(Operators[i]));
       return next;
     }
Index: /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs	(revision 2796)
@@ -39,5 +39,5 @@
         inner.Parallel = true;
         for (int i = 0; (i < ExecutionContext.Scope.SubScopes.Count) && (i < Operators.Count); i++)
-          inner.Add(new ExecutionContext(ExecutionContext.Parent, Operators[i], ExecutionContext.Scope.SubScopes[i]));
+          inner.Add(ExecutionContext.CreateContext(Operators[i], ExecutionContext.Scope.SubScopes[i]));
         next.Insert(0, inner);
       }
Index: /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 2796)
@@ -45,5 +45,5 @@
       IOperator op = OperatorParameter.ActualValue;
       if (op != null)
-        next.Insert(0, new ExecutionContext(ExecutionContext.Parent, op, ExecutionContext.Scope));
+        next.Insert(0, ExecutionContext.CreateContext(op));
       return next;
     }
